Unit tafh0c_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, AFH0C_p, ASH0C_p;

function tafh0c: String;

implementation

function tafh0c: String;
var
P,I,J,N,_i :Integer;
A :Array [0..15] of Complex;
S :Array [0..3] of Real;
X :Array [0..3] of Complex;
const
A1 :Array [0..15] of Complex = ( ( re:1.0; im:0.0 ),( re:1.0; im:0.0 ),( re:1.0; 
im:0.0 ),( re:1.0; im:0.0 ),( re:1.0; im:0.0 ),( 
re:3.0; im:0.0 ),( re:1.0; im:2.0 ),( re:3.0; 
im:0.0 ),( re:1.0; im:0.0 ),( re:1.0; im:-2.0 ),( 
re:6.0; im:0.0 ),( re:4.0; im:-2.0 ),( re:1.0; 
im:0.0 ),( re:3.0; im:0.0 ),( re:4.0; im:2.0 ),( 
re:10.0; im: 0.0 ) );
B :Array [0..3] of Complex = ( ( re:1.0; im:0.0 ),( re:1.0; im:0.0 ),( re:1.0; 
im:0.0 ),( re:1.0; im: 0.0 ) );
label
_1;
begin
Result := '';  {   }
for I:=1 to 4 do
 begin
  for J:=1 to 4 do
   begin
_1:
    A[(I-1)+(J-1)*4] := A1[(I-1)+(J-1)*4];
   end;
 end;
Result := Result + #$0D#$0A;
for J:=1 to 4 do
 begin
  for I:=1 to 4 do
   begin
    Result := Result + Format('%20.16f %20.16f ',
 [A[(I-1)+(J-1)*4].re,A[(I-1)+(J-1)*4].im]) + #$0D#$0A;
   end;
 end;
Result := Result + #$0D#$0A;
P := 1;
N := 4;
AFH0C(A,S,N);
Result := Result + #$0D#$0A;
for J:=1 to 4 do
 begin
  for I:=1 to 4 do
   begin
    Result := Result + Format('%20.16f %20.16f ',
 [A[(I-1)+(J-1)*4].re,A[(I-1)+(J-1)*4].im]) + #$0D#$0A;
   end;
 end;
Result := Result + #$0D#$0A;
Result := Result + #$0D#$0A;
for _i:=0 to 3 do
 begin
  Result := Result + Format('%20.16f ',[S[_i]]);
  if ( ((_i+1) mod 4)=0 )
   then Result := Result + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
ASH0C(A1,B,X,S,N,P);
Result := Result + #$0D#$0A;
for J:=1 to 4 do
 begin
  for I:=1 to 4 do
   begin
    Result := Result + Format('%20.16f %20.16f ',
 [A1[(I-1)+(J-1)*4].re,A1[(I-1)+(J-1)*4].im]) + #$0D#$0A;
   end;
 end;
Result := Result + #$0D#$0A;
Result := Result + #$0D#$0A;
for _i:=0 to 3 do
 begin
  Result := Result + Format('%20.16f ',[S[_i]]);
  if ( ((_i+1) mod 4)=0 )
   then Result := Result + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
Result := Result + #$0D#$0A;
for _i:=0 to 3 do
 begin
  Result := Result + Format('%20.16f %20.16f ',[B[_i].re,B[_i].im]);
  if ( ((_i+1) mod 4)=0 )
   then Result := Result + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
Result := Result + #$0D#$0A;
for _i:=0 to 3 do
 begin
  Result := Result + Format('%20.16f %20.16f ',[X[_i].re,X[_i].im]);
  if ( ((_i+1) mod 4)=0 )
   then Result := Result + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
UtRes('tafh0c',Result);  {     tafh0c.res }
exit;
end;

end.
